
uniform mat4 g_WorldViewProjectionMatrix;
uniform mat3 g_NormalMatrix;
uniform float g_Time;
uniform vec2 m_ScreenSpace;
uniform sampler2D m_ColorMap;
uniform sampler2D m_ColorMap2;
uniform float m_Scale;

attribute vec3 inPosition;
attribute vec2 inTexCoord;
attribute vec4 inColor;
attribute float inSize;

varying vec2 texCoord1;
varying vec2 texCoord2;
varying vec4 vColor;


void main(){
    texCoord1 = inTexCoord;
    //texCoord2 = inTexCoord;    
    vec4 modelSpacePos = vec4(inPosition, 1.0);
    
    #ifdef BILLBOARD
    modelSpacePos.y += texCoord1.y * m_Scale;
    //modelSpacePos.x += texCoord1.x;
    #endif
    
    vec4 dir = vec4( 1.0, 0.0, 0.0, 1.0 );
    vColor = vec4(1.0, 0.0, 0.0, 1.0); 
    
    #ifdef BILLBOARD
    texCoord2 = texCoord1 * 0.5 + vec2(0.5, 0.5);
    #else
    texCoord2 = texCoord1;
    #endif
    
    gl_Position = g_WorldViewProjectionMatrix * modelSpacePos;
    
    #ifdef BILLBOARD
    gl_Position.x += 0.75 * texCoord1.x * m_ScreenSpace.x  * m_Scale;
    //gl_Position.y += texCoord1.y * m_ScreenSpace.y;
                
    // We want it to kind of lay back a little as we look
    // straight down at it.
    vec3 up = vec3( 0.0, 1.0, 0.0 );
    up = g_NormalMatrix * up;

    vec3 side = vec3( 1.0, 0.0, 0.0 );
    side = g_NormalMatrix * side;
    
    //vColor.r = 0.5 + (side.x * 0.5);
    //vColor.g = up.y;
    //vColor.b = up.z;
 
    gl_Position.y += texCoord1.y * up.z * 0.5;
    #endif
    
}
